<template>
  <v-card>
    <v-toolbar flat>
      <v-toolbar-title>
        <v-icon color="info" class="mx-2">timeline</v-icon>
        ยอดจองสูงสุด
      </v-toolbar-title>
    </v-toolbar>
    <v-card-text>
      <v-row>
        <v-col cols="6">
          <v-toolbar
            flat
            floating
            style="background-color: transparent"
            class="d-flex justify-center"
          >
            <span class="headline-2">ยอดจองตามพื้นที่</span>
            <v-select
              class="mx-3"
              style="background-color: ##c7c7c7"
              v-model="BookingLocateRangeSelected"
              :items="RangeChoice"
              item-text="choiceName"
              item-value="choiceValue"
              prepend-icon="mdi-calendar"
              menu-props="auto"
              hide-details
              single-line
            ></v-select>
          </v-toolbar>
          <div class="text-center" v-if="loadingBookingLocate">
            <CardLoading></CardLoading>
          </div>
          <div v-else class="d-flex justify-center">
            <graph-pie
              :width="500"
              :height="600"
              :values="bookingCountBookingLocate"
              :names="locateNameBookingLocate"
              :active-event="'click'"
              :show-text-type="'outside'"
              :data-format="getBookingCount"
            >
              <legends :names="locateNameBookingLocate"></legends>
              <tooltip :names="locateNameBookingLocate"></tooltip>
            </graph-pie>
          </div>
        </v-col>
        <v-col cols="6">
          <v-toolbar
            flat
            floating
            style="background-color: transparent"
            class="d-flex justify-center"
          >
            <span class="headline-2">ยอดจองตามล็อคเกอร์</span>
            <v-select
              class="mx-3"
              style="background-color: ##c7c7c7"
              v-model="BookingLockerRangeSelected"
              :items="RangeChoice"
              item-text="choiceName"
              item-value="choiceValue"
              prepend-icon="mdi-calendar"
              menu-props="auto"
              hide-details
              single-line
            ></v-select>
          </v-toolbar>
          <div class="text-center" v-if="loadingBookingLocate">
            <CardLoading></CardLoading>
          </div>
          <div v-else class="d-flex justify-center">
            <graph-pie
              :width="500"
              :height="600"
              :values="bookingCountBookingLocker"
              :names="lockerCodeBookingLocker"
              :active-event="'click'"
              :show-text-type="'outside'"
              :data-format="getBookingCount"
            >
              <legends
                :names="lockerCodeBookingLocker"
                :dx="4"
                :dy="5"
              ></legends>
              <tooltip :names="lockerCodeBookingLocker"></tooltip>
            </graph-pie>
          </div>
        </v-col>
      </v-row>
    </v-card-text>
  </v-card>
</template>

<script>
import CardLoading from "./CardLoading";
export default {
  components: {
    CardLoading,
  },
  data() {
    return {
      lockerCodeBookingLocker: [],
      bookingCountBookingLocker: [],
      locateNameBookingLocate: [],
      bookingCountBookingLocate: [],
      loadingBookingLocate: true,
      BookingLocateRangeSelected: "D",
      BookingLockerRangeSelected: "D",
      RealBookingLockerRange: "D",
      RealBookingLocateRange: "D",
      monthValue: 0,
      RangeChoice: [
        {
          choiceName: "วันนี้",
          choiceValue: "D",
        },
        {
          choiceName: "1 สัปดาห์ที่ผ่านมา",
          choiceValue: "W",
        },
        {
          choiceName: "1 เดือนที่ผ่านมา",
          choiceValue: "M1",
        },
        {
          choiceName: "3 เดือนที่ผ่านมา",
          choiceValue: "M3",
        },
        {
          choiceName: "6 เดือนที่ผ่านมา",
          choiceValue: "M6",
        },
        {
          choiceName: "1 ปีที่ผ่านมา",
          choiceValue: "Y",
        },
      ],
    };
  },
  watch: {
    async BookingLocateRangeSelected() {
      this.locateNameBookingLocate = [];
      this.bookingCountBookingLocate = [];
      this.RealBookingLocateRange = this.BookingLocateRangeSelected;
      switch (this.BookingLocateRangeSelected) {
        case "W":
          this.monthValue = 0;
          break;
        case "D":
          this.monthValue = 0;
          break;
        case "M1":
          this.monthValue = 1;
          this.RealBookingLocateRange = "M";
          break;
        case "M3":
          this.monthValue = 3;
          this.RealBookingLocateRange = "M";
          break;
        case "M6":
          this.monthValue = 6;
          this.RealBookingLocateRange = "M";
          break;
        case "Y":
          this.monthValue = 0;
          break;

        default:
          break;
      }
      await this.fetchBookingCountLocate();
      this.loadingBookingLocate = false;
    },
    async BookingLockerRangeSelected() {
      this.lockerCodeBookingLocker = [];
      this.bookingCountBookingLocker = [];
      this.RealBookingLockerRange = this.BookingLockerRangeSelected;
      switch (this.BookingLockerRangeSelected) {
        case "W":
          this.monthValue = 0;
          break;
        case "D":
          this.monthValue = 0;
          break;
        case "M1":
          this.monthValue = 1;
          this.RealBookingLockerRange = "M";
          break;
        case "M3":
          this.monthValue = 3;
          this.RealBookingLockerRange = "M";
          break;
        case "M6":
          this.monthValue = 6;
          this.RealBookingLockerRange = "M";
          break;
        case "Y":
          this.monthValue = 0;
          break;

        default:
          break;
      }
      await this.fetchBookingCountLocker();
      this.loadingBookingLocker = false;
    },
  },
  async created() {
    await this.fetchBookingCountLocker();
    await this.fetchBookingCountLocate();
    this.loadingBookingLocker = false;
    this.loadingBookingLocate = false;
  },
  methods: {
    getBookingCount(a, b) {
      return b;
    },
    async fetchBookingCountLocker() {
      const param = {
        BookingLockerRangeSelected: this.RealBookingLockerRange,
        monthValue: this.monthValue,
      };
      await this.$store.dispatch("dashboard/getBookingLocker", param);
      let bookingLockerResult = this.$store.getters["dashboard/bookingLocker"];
      bookingLockerResult.forEach((element) => this.setBookingLocker(element));
    },
    setBookingLocker(data) {
      this.lockerCodeBookingLocker.push(
        `${data.lockerCode} - ${data.locateName}`
      );
      this.bookingCountBookingLocker.push(data.bookingCount);
    },
    async fetchBookingCountLocate() {
      const param = {
        BookingLocateRangeSelected: this.RealBookingLocateRange,
        monthValue: this.monthValue,
      };
      await this.$store.dispatch("dashboard/getBookingLocate", param);
      let bookingLocateResult = this.$store.getters[
        "dashboard/bookingLocation"
      ];
      bookingLocateResult.forEach((element) => this.setBookingLocate(element));
    },
    setBookingLocate(data) {
      this.locateNameBookingLocate.push(data.locateName);
      this.bookingCountBookingLocate.push(data.bookingCount);
    },
  },
};
</script>

<style>
</style>